// © 2021 ETH Zurich, Mechanics and Materials Lab
//
// This file is part of ae108.
//
// ae108 is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// ae108 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ae108. If not, see <https://www.gnu.org/licenses/>.

#include "ae108/solve/AffineTransform.h"
#include "ae108/cpppetsc/ParallelComputePolicy_fwd.h"
#include "ae108/cpppetsc/SequentialComputePolicy_fwd.h"

namespace ae108::solve {

extern template struct AffineTransform<cpppetsc::SequentialComputePolicy>;
extern template struct AffineTransform<cpppetsc::ParallelComputePolicy>;

template cpppetsc::distributed<
    typename AffineTransform<cpppetsc::SequentialComputePolicy>::vector_type>
apply(const AffineTransform<cpppetsc::SequentialComputePolicy> &,
      const cpppetsc::distributed<typename AffineTransform<
          cpppetsc::SequentialComputePolicy>::vector_type> &);
template cpppetsc::distributed<
    typename AffineTransform<cpppetsc::ParallelComputePolicy>::vector_type>
apply(const AffineTransform<cpppetsc::ParallelComputePolicy> &,
      const cpppetsc::distributed<typename AffineTransform<
          cpppetsc::ParallelComputePolicy>::vector_type> &);

template void
apply(const AffineTransform<cpppetsc::SequentialComputePolicy> &transform,
      const cpppetsc::distributed<typename AffineTransform<
          cpppetsc::SequentialComputePolicy>::vector_type> &,
      cpppetsc::distributed<typename AffineTransform<
          cpppetsc::SequentialComputePolicy>::vector_type> *const);
template void
apply(const AffineTransform<cpppetsc::ParallelComputePolicy> &transform,
      const cpppetsc::distributed<typename AffineTransform<
          cpppetsc::ParallelComputePolicy>::vector_type> &,
      cpppetsc::distributed<typename AffineTransform<
          cpppetsc::ParallelComputePolicy>::vector_type> *const);

} // namespace ae108::solve
